SystemOrganization addCategory: #'SourceCity-Core'!

Object subclass: #AbstractCityComponent
	instanceVariableNames: 'name dimension color position dependencies'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!AbstractCityComponent commentStamp: '<historical>' prior: 0!
I'm an abstract class root of the city elements!

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 16:00'!
absolutePosition
	^ self subclassResponsibility! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:24'!
addDependencies: anObject
	self dependencies add: anObject.! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ color! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color: anObject
	color := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
dependencies
	^ dependencies! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
dependencies: anObject
	dependencies := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension

	^ dimension! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 11:20'!
dimension: anObject

	dimension := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/13/2012 11:23'!
initialize
	dependencies := #().! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:40'!
name
	^name asString! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/4/2012 13:08'!
name: anObject
	name := anObject! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position

	^ position! !

!AbstractCityComponent methodsFor: 'accessing' stamp: 'blo 7/5/2012 10:31'!
position: anObject

	position := anObject! !

AbstractCityComponent subclass: #Building
	instanceVariableNames: 'district'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!Building commentStamp: '<historical>' prior: 0!
A Building is the level abstraction.!

!Building class methodsFor: 'instance creation' stamp: 'DouailleErwan 7/11/2012 20:00'!
named: aName inDistrict: aDistrict dimension: a3Ddimension color: aColor dependencies: aCollection

	^ self new 
		name: aName;
		dimension: a3Ddimension;
		district: aDistrict;
		color: aColor;
		dependencies: aCollection.! !

!Building methodsFor: 'accessing' stamp: 'blo 7/5/2012 16:01'!
absolutePosition
	^ self position + self district absolutePosition! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
district
	^ district! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 15:27'!
district: anObject
	district := anObject.
	district add: self.! !

!Building methodsFor: 'initialize' stamp: 'DouailleErwan 7/11/2012 12:28'!
initialize 
	dependencies := Collection new.! !

!Building methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:40'!
printOn: aStream

	district ifNotNil: [ aStream
		nextPutAll: district asString; 
		nextPutAll: ' -> '].
	name ifNotNil: [ aStream 
		nextPutAll: ' Building: '; 
		nextPutAll: self name ].! !

AbstractCityComponent subclass: #City
	instanceVariableNames: 'districts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!City commentStamp: '<historical>' prior: 0!
A City represents the largest model element. It contains a list of districts.!

!City class methodsFor: 'instance creation' stamp: 'blo 7/4/2012 15:16'!
named: aName
	^ self new 
		name: aName.
		! !

!City methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 16:01'!
absolutePosition
	^ self position! !

!City methodsFor: 'adding' stamp: 'blo 7/5/2012 12:33'!
add: aDistrict

	districts add: aDistrict.
	^ aDistrict! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:29'!
color
	^ Color r: 0.6 g: 0.6 b: 0.6! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts
	^ districts! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:15'!
districts: anObject
	districts := anObject! !

!City methodsFor: 'comparing' stamp: 'DouailleErwan 6/12/2012 10:22'!
hasDistrictNamed: aString

	^ districts anySatisfy: [ :each | each model name = aString ]! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:22'!
initialize

	super initialize.
	districts := OrderedCollection new.! !

!City methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:29'!
printOn: aStream

	name ifNotNil: [ aStream 
		nextPutAll: ' City: '; 
		nextPutAll: self name].! !

AbstractCityComponent subclass: #District
	instanceVariableNames: 'buildings city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!District commentStamp: '<historical>' prior: 0!
A District is a secondary city abstractions!

!District class methodsFor: 'instance creation' stamp: 'blo 7/4/2012 14:52'!
named: aName inCity: aCity

	^ self new
		name: aName;
		city: aCity.! !

!District methodsFor: 'adding' stamp: 'blo 7/8/2012 13:47'!
absolutePosition
	^ self position + self city absolutePosition! !

!District methodsFor: 'adding' stamp: 'blo 7/5/2012 12:34'!
add: aBuilding

	buildings add: aBuilding.
	^ aBuilding.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings
	^ buildings! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
buildings: anObject
	buildings := anObject! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 6/12/2012 10:16'!
city
	^ city! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 15:27'!
city: anObject
	city := anObject.
	city add: self.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:30'!
color
	^Color r: 0.8 g: 0.8 b:0.8! !

!District methodsFor: 'comparing' stamp: 'DouailleErwan 6/15/2012 12:38'!
hasBuildingNamed: aString

	^ buildings anySatisfy: [ :each | each model name = aString ]! !

!District methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 14:52'!
initialize 
	
	super initialize.
	buildings := OrderedCollection new.! !

!District methodsFor: 'accessing' stamp: 'DouailleErwan 7/11/2012 20:40'!
printOn: aStream

	city ifNotNil: [ aStream
		nextPutAll: city asString;
		nextPutAll: '-> '].
	name ifNotNil: [ aStream 
		nextPutAll: ' District: '; 
		nextPutAll: self name].! !

Object subclass: #SourceCityFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Core'!

!SourceCityFactory commentStamp: '<historical>' prior: 0!
I do all the creation context of the city. Create all districts, buildings, caluclate each height ....!

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/12/2012 12:10'!
createBuilding: anObject district: aDistrict strategy: aStrategy
	^ Building named: (aStrategy buildingNameGenerator value: anObject)
		inDistrict: aDistrict 
		dimension: (aStrategy normalizedBuildingDimension value: anObject)
		color: (aStrategy normalizedColor value: anObject )
		dependencies: (aStrategy dependenciesSelector value: anObject ).
	! !

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/10/2012 15:26'!
createCity: anObject named: aName strategy: aStrategy
	| districtObjects city id |
	districtObjects := aStrategy districtsSelector value: anObject.
	city := City named: aName.
	districtObjects do: [:district | 
		self createDistrict: district city: city strategy: aStrategy
		] displayingProgress: [:aDistrict | 'Build District: ', aDistrict name].
	^city.! !

!SourceCityFactory class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/10/2012 15:26'!
createDistrict: anObject city: aCity strategy: aStrategy
	| district |
	district := District named: (aStrategy districtNameGenerator value: anObject) inCity: aCity.
	(aStrategy buildingsSelector value: anObject) do: [:building |
		self createBuilding: building district: district strategy: aStrategy 
		].
	^district
	! !

!Float methodsFor: '*SourceCity-Core' stamp: 'DouailleErwan 7/10/2012 15:16'!
roundedUp
	"Return a rounded up"
	self sign = 1
	ifTrue:  [^self truncated + self sign rounded.].
	self sign = 0
	ifTrue: [^self truncated].
	self sign = -1
	ifTrue:  [^self sign rounded.].! !
